#pragma once

//CũCN[h
#pragma comment(lib, "d3dxof.lib")
#pragma comment(lib, "dxguid.lib")
#pragma comment(lib, "d3d9.lib")
#pragma comment(lib, "winmm.lib")
#ifdef _DEBUG
#pragma comment(lib, "d3dx9d.lib")
#else
#pragma comment(lib, "d3dx9.lib")
#endif



#define _CRT_SECURE_NO_WARNINGS
#include <windows.h>
#include <d3dx9.h>

const wchar_t CLASSNAME[] = L"testprogram";
const wchar_t APPNAME[] = L"Test Program";

IDirect3D9 *pD3D = NULL;
IDirect3DDevice9 *pD3DDevice = NULL;

LRESULT WINAPI MsgProc(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam){
    switch(msg){
        case WM_DESTROY:
            PostQuitMessage(0);
            return 0;
    }
    return DefWindowProc(hWnd, msg, wParam, lParam);
}


int APIENTRY WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nCmdShow)
{
    const int dispx = 800;
    const int dispy = 600;

	MSG msg;
    ZeroMemory(&msg, sizeof(msg));

	WNDCLASSEX wc;
    ZeroMemory(&wc, sizeof(WNDCLASSEX));

    wc.cbSize	     = sizeof(WNDCLASSEX);
	wc.style         = CS_CLASSDC;
	wc.lpfnWndProc   = MsgProc;
	wc.hInstance     = hInstance;
	wc.lpszClassName = CLASSNAME;
    wc.hCursor       = LoadCursor(NULL , IDC_ARROW);
	
	if (RegisterClassEx(&wc)==NULL)
		PostQuitMessage(0);

    HWND hWnd = CreateWindow(CLASSNAME, APPNAME, WS_OVERLAPPEDWINDOW, 0, 0, dispx, dispy, NULL, NULL, wc.hInstance, NULL);

	if (hWnd==NULL)
		PostQuitMessage(0);

	//EBhETCY
    RECT Rect;
    GetClientRect(hWnd, &Rect);
    MoveWindow(hWnd, NULL, NULL, dispx+(dispx-Rect.right), dispy+(dispy-Rect.bottom),false);

	D3DPRESENT_PARAMETERS   d3dpp;
	ZeroMemory(&d3dpp, sizeof(D3DPRESENT_PARAMETERS)); 

	pD3D = Direct3DCreate9(D3D_SDK_VERSION);

	d3dpp.BackBufferCount        = 0;
    d3dpp.SwapEffect             = D3DSWAPEFFECT_DISCARD;
    d3dpp.PresentationInterval   = D3DPRESENT_INTERVAL_IMMEDIATE;
    d3dpp.Windowed               = true;
    d3dpp.BackBufferHeight       = dispy;
    d3dpp.BackBufferWidth        = dispx;
    d3dpp.hDeviceWindow          = hWnd;
    d3dpp.EnableAutoDepthStencil = true;
    d3dpp.AutoDepthStencilFormat = D3DFMT_D16;
    d3dpp.BackBufferFormat		 = D3DFMT_UNKNOWN;

	pD3D->CreateDevice(D3DADAPTER_DEFAULT,
                        D3DDEVTYPE_HAL,
                        hWnd,
                        D3DCREATE_SOFTWARE_VERTEXPROCESSING,
                        &d3dpp,
                        &pD3DDevice);

    // Show the window
	ShowWindow(hWnd, SW_SHOWDEFAULT);
	UpdateWindow(hWnd);

	// Enter the message loop
	while( msg.message!=WM_QUIT ){
		if( PeekMessage( &msg, NULL, 0U, 0U, PM_REMOVE ) ){
			TranslateMessage( &msg );
			DispatchMessage( &msg );
        }else{
			pD3DDevice->Clear( 0, NULL, D3DCLEAR_TARGET, D3DCOLOR_XRGB( 0, 190, 255 ), 1.0f, 0 );
			pD3DDevice->BeginScene();
			pD3DDevice->EndScene();
			pD3DDevice->Present( NULL, NULL, NULL, NULL );
        }
	}

	pD3DDevice->Release();
	pD3D->Release();

	UnregisterClass(CLASSNAME, hInstance);
    return (int)msg.wParam;

}
